	name MCSTUB
	.386p
	include vmm.inc
	include ilb.inc
	include drp.inc
	include vwin32.inc

VxD_IDATA_SEG

; MC_ILB -- IOS Linkage Block (IOS=I/O Supervisor)
; Gets stuffed with pointers to I/O Supervisor functions when we call
;    IOS_Register()
; However, we have no use for these, so we put this in the
; initialization segment where it will be thrown away.

MC_ILB	ILB		<>

VxD_IDATA_ENDS

VxD_LOCKED_DATA_SEG

; MC_DRP -- Device Registration Packet for IOS
; The C-language OnDeviceInit() routine needs to pass a pointer to this
; to IOS_Register(), so we make this a C-visible name
	public _MC_DRP

_MC_DRP	DRP		<EyeCatcher,	\   ; Eyecatcher string for mem dumps
				DRP_TSD,		\	; IOS stack position
				0,				\   ; addr of async event routine
				offset32 MC_ILB,\	; addr of ILB
				'CodaMinicache   '> ; 16-char driver name

VxD_LOCKED_DATA_ENDS

; MCVxD_DDB -- device header, exported to the VxD loader by being
; mentioned in the .MAP file

;	EXTRN	_MC_PM_API:NEAR

MCSTUB_Device_Id equ 01234h
Create_MCSTUB_Service_Table   equ   1

Begin_Service_Table MCSTUB
    MCSTUB_Service     MCSTUB_Get_Version, LOCAL
    MCSTUB_Service     _MCSTUB_Get_ConnectNetResource
    MCSTUB_Service     _MCSTUB_Set_ConnectNetResource  
	MCSTUB_Service	   _MCSTUB_Get_AsyncEvent
	MCSTUB_Service	   _MCSTUB_Set_AsyncEvent
	MCSTUB_Service	   _MCSTUB_Get_ProviderId
End_Service_Table MCSTUB

Declare_Virtual_Device MCSTUB,		\	; VxD name
	0, 90,						\	; major, minor version
	MC_Control,					\	; control dispatch routine
	MCSTUB_Device_ID,			\	; undefined device ID
	<FSD_Init_Order+80h>,		\	; initialiation order
	 , ,						\	; V86, PM APIs
	_MC_DRP							; device registration packet

VxD_LOCKED_CODE_SEG

; MC_Control -- routine dispatches VxD messages from VMM

Begin_Control_Dispatch MC

Control_Dispatch Device_Init, _OnDeviceInit, cCall, <>
; Control_Dispatch W32_DeviceIoControl, _OnW32DeviceIoControl, cCall, <ebx, esi>

End_Control_Dispatch MC


BeginProc MCSTUB_Get_Version
			mov		eax, 10h
			clc
			ret
EndProc MCSTUB_Get_Version

VxD_LOCKED_CODE_ENDS

; following two segments are placed before
; and after .bss (see .def file) -- C code
; will clear the bss during OnDeviceInit

_BSS_START	segment	dword flat 'lcode'
			public _BSSstart
_BSSstart	dd	0
_BSS_START	ends

_BSS_END	segment dword flat 'lcode'
			public _BSSend
_BSSend	dd	0
_BSS_END	ends

	end


